#!/usr/bin/python

# RocketPong by Nirav Patel
# 
# This is an entry for Game Creation Society's first game design compo.
# The competition was to design a one button game.
# This game sucks, but it does use only one button.
# I'm going to call it public domain because I'm too lazy to dig out gpl.txt
# The rocket gifs are GNU FDL modified from:
# http://commons.wikimedia.org/wiki/Image:Bell%27s_spaceship_paradox_-_spaceships.pnghttp://commons.wikimedia.org/wiki/Image:Bell%27s_spaceship_paradox_-_spaceships.png

import time, random, sys
import pygame
from pygame.locals import *

pygame.init()

class RocketPong(object):
   size = ( 640, 480 )
   bsize = 50
   def __init__(self, **argd):
       self.__dict__.update(**argd)
       super(RocketPong, self).__init__(**argd)
       self.display = pygame.display.set_mode( self.size )
       pygame.display.set_caption('RocketPong')
       self.clock = pygame.time.Clock()
       
       self.ball = pygame.surface.Surface((50,50), 0, 24)
       self.ball.set_colorkey((0,0,0))
       self.ball.fill((0,0,0))
       pygame.draw.circle(self.ball,(50,200,100), (self.bsize/2,self.bsize/2), self.bsize/2, 0)
       self.bmask = pygame.mask.from_surface(self.ball)
       self.coord = (self.size[0]/2,self.size[1]/2)
       self.yv = 5
       self.xv = 5       
       
       self.flame = pygame.surface.Surface((20,30),0,24)
       self.flame.set_colorkey((0,0,0))
       self.flame.fill((0,0,0))
       pygame.draw.polygon(self.flame, (255,100,20),[(0,0),(20,0),(10,30)])
       pygame.draw.polygon(self.flame, (255,180,70),[(5,0),(15,0),(10,16)])
       self.player = pygame.image.load('player.gif')
       self.enemy = pygame.image.load('enemy.gif')
       self.player.set_colorkey((0,0,0))
       self.enemy.set_colorkey((0,0,0))
       self.pmask = pygame.mask.from_surface(self.player)
       self.emask = pygame.mask.from_surface(self.enemy)
       self.playerpos = 380
       self.playerv = 0
       self.playerscore = 0
       self.enemypos = 380
       self.enemyv = 0
       self.enemyscore = 0
       self.paccel = False
       self.eaccel = False
       self.p2 = False
 
       random.seed()
       

            
   def get_and_flip(self):
       self.display.fill((0,0,0))

       self.yv += 1
       self.playerv += 1
       self.enemyv += 1
       self.playerpos += self.playerv
       self.enemypos += self.enemyv
       

           
       
       if self.playerpos > 380:
           self.playerpos = 380
           self.playerv = 0
       if self.playerpos < 0:
           self.playerpos = 0
           self.playerv = 0
           
       if self.enemypos > 380:
           self.enemypos = 380
           self.enemyv = 0
       if self.enemypos < 0:
           self.enemypos = 0
           self.enemyv = 0
       
       if self.p2:
           if self.eaccel:
               self.enemyv -= 3
               self.display.blit(self.flame, (585, self.enemypos+100))
       else:
           if self.coord[1]+100 < self.enemypos and self.yv < 0 and self.xv > 0:
               self.enemyv -= 3
               self.display.blit(self.flame, (585, self.enemypos+100))
       
       if self.paccel:        
           self.playerv -= 3
           self.display.blit(self.flame, (35, self.playerpos+100))
           
       self.display.blit(self.player, (20, self.playerpos))
       self.display.blit(self.enemy, (570, self.enemypos))
       
       scorestring = "RocketPong: Us = " + str(self.playerscore) +"   "+"Them = "+str(self.enemyscore)
       
       pygame.display.set_caption(scorestring)

       self.coord = (self.coord[0]+self.xv, self.coord[1]+self.yv)       
       self.display.blit(self.ball, self.coord)

       if self.coord[0] > self.size[0]-self.bsize:
           self.xv = 5
           self.yv = 5
           self.coord = (self.size[0]/2,self.size[1]/2)
           self.playerscore += 1
           pygame.time.wait(500)
       if self.coord[0] < 0:
           self.xv = 5
           self.yv = 5
           self.coord = (self.size[0]/2,self.size[1]/2)
           self.enemyscore += 1
           pygame.time.wait(500)
       if self.coord[1] > self.size[1]-self.bsize:
           self.yv = (-self.yv)
           self.coord = (self.coord[0], self.size[1]-self.bsize)
       if self.coord[1] < 0:
           self.yv = (-self.yv)-1
           self.coord = (self.coord[0], 0)       
               
       poverlap = self.bmask.overlap(self.pmask, (self.coord[0]-20,self.coord[1]-50-self.playerpos))
       if poverlap:
           dx = self.bmask.overlap_area(self.pmask, (self.coord[0]-21,self.coord[1]-50-self.playerpos)) - self.pmask.overlap_area(self.bmask, (self.coord[0]-19,self.coord[1]-50-self.playerpos))
           dy = self.bmask.overlap_area(self.pmask, (self.coord[0]-20,self.coord[1]-51-self.playerpos)) - self.pmask.overlap_area(self.bmask, (self.coord[0]-20,self.coord[1]-49-self.playerpos))
           if dy < -10:
               dy = -10
           if dy > 10:
               dy = 10

           self.xv = max(7,min(15,min(5,dx/6) + (poverlap[0]-25)/4))
           self.yv = -dy/6 - (poverlap[1]-25)/4 + self.playerv
           self.coord = (self.coord[0]+(poverlap[0]-25), self.coord[1]-poverlap[1])
       
       eoverlap = self.bmask.overlap(self.emask, (self.coord[0]-570,self.coord[1]-50-self.enemypos))
       if eoverlap:
           dx = self.bmask.overlap_area(self.emask, (self.coord[0]-571,self.coord[1]-50-self.enemypos)) - self.emask.overlap_area(self.bmask, (self.coord[0]-569,self.coord[1]-50-self.enemypos))
           dy = self.bmask.overlap_area(self.emask, (self.coord[0]-570,self.coord[1]-51-self.enemypos)) - self.emask.overlap_area(self.bmask, (self.coord[0]-570,self.coord[1]-49-self.enemypos))
           if dy < -10:
               dy = -10
           if dy > 10:
               dy = 10
           self.xv = min(-7,max(-15,max(-5,-dx/6) - (eoverlap[0]-25)/4))
           self.yv = -dy/6 - (eoverlap[1]-25)/4 + self.enemyv
           self.coord = (self.coord[0]-eoverlap[0], self.coord[1]-eoverlap[1])
            
       pygame.display.flip()

   def main(self):

       going = True
       while going:
           events = pygame.event.get()
           for e in events:
               if e.type == QUIT or (e.type == KEYDOWN and e.key == K_ESCAPE):
                   going = False
               if e.type == KEYDOWN and e.key != K_ESCAPE and e.key != K_RIGHT:
                   self.paccel = True
               if e.type == KEYUP and e.key != K_ESCAPE and e.key != K_RIGHT:
                   self.paccel = False
               if e.type == KEYDOWN and e.key == K_RIGHT:
                   self.p2 = True
                   self.eaccel = True
               if e.type == KEYUP and e.key == K_RIGHT:
                   self.eaccel = False
           
           self.get_and_flip()
           self.clock.tick(30)
       pygame.quit()
       sys.exit()

RocketPong().main()
